/* babirl : skelbabies/skelbabies.h
 * 
 * Hidetada Baba (RIKEN)
 * baba@ribf.riken.jp
 * Header for Event fragment sender
 *
 */

/* macros */
#ifdef DEBUG
#define DB(x) x
#else
#define DB(x)
#endif

typedef int boolean;

// default values, written in bi-config.h and bi-common.h
#define MAXEF 254
#define BABIRL_COM_SIZE    1024*10 ///< Buffer size for babirl tcp commands 
#define ERRCVPORT   17601
/** 17651-18000 : for babies communication port */
#define ESCOMPORT   17651
#define EB_EFBLOCK_SIZE 0x200000   ///< Usual max size of block data = 2MB
#define EB_EFBLOCK_BUFFSIZE EB_EFBLOCK_SIZE * 2  ///< Usual size of block data b
#define TRUE  1
#define FALSE 0
#define STAT_RUN_IDLE     0
#define STAT_RUN_START    1
#define STAT_RUN_NSSTA    2
#define STAT_RUN_WAITSTOP 3
/** babies tcp commands */
#define ES_SET_CONFIG    1
#define ES_GET_CONFIG    2
#define ES_RUN_START     3
#define ES_RUN_NSSTA     4
#define ES_RUN_STOP      5
#define ES_RELOAD_DRV    6
#define ES_GET_EVTN      8    // Get last event number
#define ES_CON_EFR      11    // Connect EFS to EFR
#define ES_DIS_EFR      12    // Disconnect EFS to EFR
#define ES_QUIT         99
/** babies tcp arguments */
#define ES_EF_ON    0x00000000    // Join event build
#define ES_EF_OFF   0x80000000    // Not join event build
#define WHOAREYOU        98

/*! Structure for event fragment resource */
struct stefrc
{
	int efid;          ///< EFID
	char runname[80];  ///< Run name (RIDF file name)
	int runnumber;     ///< Run number
	short erport;      ///< ER port
	short comport;     ///< ES communication port
	char erhost[80];   ///< ER hostname
	int hd1;           ///< Flag for HDD1
	char hd1dir[80];   ///< Path of HDD1
	int hd2;           ///< Flag for HDD2
	char hd2dir[80];   ///< Path of HDD2
	int mt;            ///< Flag for MT
	char mtdir[80];    ///< Path of MT
	int connect;       ///< Connectivity of ER (0=disconnected., 1=connected)
};

/* prototype */
void quit(void);
int reset(void);
int sethd1(boolean t);
int sethd1dir(char *name);
int sethd2(boolean t);
int sethd2dir(char *name);
int setmt(boolean t);
int setmtdir(char *name);
int seterhost(char *name);
int setefid(int id);
int setexpname(char *name);
int setrunnumber(int n);
int efr_connect(void);
void rtthread(void);

/* common variavle */
extern struct stefrc efrc;
extern int efsock;
extern unsigned int evtn;
