/**
 * @file MemBusServer.h
 * @created Dec 14, 2012
 * @author anvar
 * ---------------------------------------------------------------------------------------------------------------------
 * © Commissariat a l'Energie Atomique et aux Energies Alternatives (CEA)
 * ---------------------------------------------------------------------------------------------------------------------
 * Contributors: Shebli Anvar (shebli.anvar@cea.fr)
 * ---------------------------------------------------------------------------------------------------------------------
 * This file is part of the Mordicus software project.
 * ---------------------------------------------------------------------------------------------------------------------
 * FREE SOFTWARE LICENCING
 * This software is governed by the CeCILL license under French law and abiding by the rules of distribution of free
 * software. You can use, modify and/or redistribute the software under the terms of the CeCILL license as circulated by
 * CEA, CNRS and INRIA at the following URL: "http://www.cecill.info". As a counterpart to the access to the source code
 * and rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty
 * and the software's author, the holder of the economic rights, and the successive licensors have only limited
 * liability. In this respect, the user's attention is drawn to the risks associated with loading, using, modifying
 * and/or developing or reproducing the software by the user in light of its specific status of free software, that may
 * mean that it is complicated to manipulate, and that also therefore means that it is reserved for developers and
 * experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the
 * software's suitability as regards their requirements in conditions enabling the security of their systems and/or data
 * to be ensured and, more generally, to use and operate it in the same conditions as regards security. The fact that
 * you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.
 * ---------------------------------------------------------------------------------------------------------------------
 * COMMERCIAL SOFTWARE LICENCING
 * You can obtain this software from CEA under other licencing terms for commercial purposes. For this you will need to
 * negotiate a specific contract with a legal representative of CEA.
 * =====================================================================================================================
 */


#ifndef demo_mdcs_hw_MemBusServer_h_INCLUDED
#define demo_mdcs_hw_MemBusServer_h_INCLUDED

#include "mdcs/hw/DeviceMediatorImpl.hpp"
#include "MemBusDeviceUint32.h"

namespace demo
{
namespace mdcs
{
namespace hw
{

class MemBusServer : public ::mdcs::hw::DeviceMediatorImpl<MemBusDeviceUint32>
{
public:
	typedef ::mdcs::hw::DeviceMediatorImpl<MemBusDeviceUint32> Base;
	typedef typename Base::DevConfig   DevConfig;
	typedef typename Base::RegConfig   RegConfig;
	typedef typename Base::Register    Register;
	typedef typename Base::BitFieldKey  BitFieldKey;
	typedef typename Base::FactoryMap  FactoryMap;
	typedef typename Base::Factory     Factory;
	typedef typename Base::DeviceMap   DeviceMap;
	typedef typename Base::Map         Map;
	typedef typename Base::DeviceCore  DeviceCore;
	typedef ::mdcs::cfg::ConfigData     ConfigData;

	MemBusServer(const ConfigData& cfg, InstanceNumber num) : Base(cfg, num) {}

	Config configData2Config(const ConfigData& cfgString); ///< @override abstract method
};

} // namespace hw
} // namespace mdcs
} // namespace demo

#endif /* demo_mdcs_hw_MemBusServer_h_INCLUDED */
