/**
 * @file Constants.cpp
 * @date 12 avr. 2013
 * @author fchateau
 * @note
 * SVN tag: $Id$
 *
 * Contributors: Frederic Chateau
 *
 * This file is part of the Mordicus software project.
 *
 * @copyright © Commissariat a l'Energie Atomique et aux Energies Alternatives (CEA)
 *
 * @par FREE SOFTWARE LICENCING
 * This software is governed by the CeCILL license under French law and abiding  * by the rules of distribution of free
 * software. You can use, modify and/or redistribute the software under the terms of the CeCILL license as circulated by
 * CEA, CNRS and INRIA at the following URL: "http://www.cecill.info". As a counterpart to the access to the source code
 * and rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty
 * and the software's author, the holder of the economic rights, and the successive licensors have only limited
 * liability. In this respect, the user's attention is drawn to the risks associated with loading, using, modifying
 * and/or developing or reproducing the software by the user in light of its specific status of free software, that may
 * mean that it is complicated to manipulate, and that also therefore means that it is reserved for developers and
 * experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the
 * software's suitability as regards their requirements in conditions enabling the security of their systems and/or data
 * to be ensured and, more generally, to use and operate it in the same conditions as regards security. The fact that
 * you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.
 *
 * @par COMMERCIAL SOFTWARE LICENCING
 * You can obtain this software from CEA under other licencing terms for commercial purposes. For this you will need to
 * negotiate a specific contract with a legal representative of CEA.
 *
 */

#include "Constants.h"

namespace mdcs
{
namespace cfg
{

const char DEFAULT_CONFIG_TYPE[] = "CCfg-Xml";
const char PROCESSOR_DEFAULT_IDENTITY[] = "DataProcessor";
const char PROCESSOR_APPNAME[]       = "DataProcessor";
const char PROCESSOR_SM_NAME[]       = "Processor";
const char PROCESSOR_CTRL_SERVANT[]  = "daq";
const char PROCESSOR_FLOW_ADAPTER[]  = "DataProcessor.Flow";
const char PROCESSOR_FLOW_SERVANT[]  = "DataProcessor";
const char GENERATOR_DEFAULT_IDENTITY[] = "DataGenerator";
const char GENERATOR_APPNAME[]       = "DataGenerator";
const char GENERATOR_SM_NAME[]       = "Generator";
const char GENERATOR_CTRL_SERVANT[]  = "generator";
const char CONTROLLER_DEFAULT_IDENTITY[] = "DataController";
const char CONTROLLER_APPNAME[]       = "DataController";
const char CONTROLLER_SM_NAME[]       = "Controller";
const char CONTROLLER_CTRL_SERVANT[]  = "controller";
const char RUNCONTROL_APPNAME[]      = "RunControl";
const char RUNCONTROL_CTRL_SERVANT[] = "StateMachine";
const char RUNCONTROL_DEFAULT_IDENTITY[] = "RunControl";
const char RUNCONTROL_STATEMACHINE[] = "DaqRunControl";
const char COMMAND_LINE_NAMESPACE[]  = "Mordicus";

} /* namespace cfg */
} /* namespace mdcs */
