/**
 * @file MordicusRunControl.h
 * @date 15 janv. 2014
 * @author fchateau
 * @note
 * SVN tag: $Id$
 *
 * Contributors: Frederic Chateau
 *
 * This file is part of the Mordicus software project.
 *
 * @copyright © Commissariat a l'Energie Atomique et aux Energies Alternatives (CEA)
 *
 * @par FREE SOFTWARE LICENCING
 * This software is governed by the CeCILL license under French law and abiding  * by the rules of distribution of free
 * software. You can use, modify and/or redistribute the software under the terms of the CeCILL license as circulated by
 * CEA, CNRS and INRIA at the following URL: "http://www.cecill.info". As a counterpart to the access to the source code
 * and rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty
 * and the software's author, the holder of the economic rights, and the successive licensors have only limited
 * liability. In this respect, the user's attention is drawn to the risks associated with loading, using, modifying
 * and/or developing or reproducing the software by the user in light of its specific status of free software, that may
 * mean that it is complicated to manipulate, and that also therefore means that it is reserved for developers and
 * experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the
 * software's suitability as regards their requirements in conditions enabling the security of their systems and/or data
 * to be ensured and, more generally, to use and operate it in the same conditions as regards security. The fact that
 * you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.
 *
 * @par COMMERCIAL SOFTWARE LICENCING
 * You can obtain this software from CEA under other licencing terms for commercial purposes. For this you will need to
 * negotiate a specific contract with a legal representative of CEA.
 *
 */

#ifndef MORDICUSRUNCONTROL_H_
#define MORDICUSRUNCONTROL_H_

#include "GuiApplication.h"
#include <Utils/Ui/DesignedWidget.hpp>
#include <QDesignerCustomWidgetInterface>
#include <QMainWindow>

// forward declaration
class Ui_MordicusRunControl;

namespace mdcs
{
namespace gui
{
// QDESIGNER_WIDGET_EXPORT

class MordicusRunControl :
	public MasterGuiApplication,
	public Utils::Ui::DesignedWidget<Ui_MordicusRunControl, QMainWindow>
{
//	Q_OBJECT
public:
//	class PluginDescriptor;
	class Params;

	MordicusRunControl(const Params& params, acq::ApplicationLoader& loader);
	~MordicusRunControl();

	QMainWindow& mainWindow() { return static_cast<QMainWindow&>(*this); }

	static CCfg::Model::ConfigSetModel::Params* defaultConfigSetTemplate();

protected:
	void closeEvent(QCloseEvent* event);

private:
	static const Descriptor& descriptor();
};

class MordicusRunControl::Params : public acq::ApplicationParamsHelper<MordicusRunControl, MasterGuiApplication>
{
public:
	template<class C> static void init(Params& p, const C& config);
};

//class MordicusRunControl::PluginDescriptor : public QObject, public QDesignerCustomWidgetInterface
//{
//	Q_OBJECT
//	Q_INTERFACES(QDesignerCustomWidgetInterface)
//public:
////	PluginDescriptor(QObject *parent = 0);
//	~PluginDescriptor();
////	QString	codeTemplate () const;
//    QWidget *createWidget(QWidget *parent);
////    QString domXml() const;
//    QString group() const;
//    QIcon icon() const;
//    QString includeFile() const;
////    void initialize(QDesignerFormEditorInterface *core);
//    bool isContainer() const;
////    bool isInitialized() const;
//    QString name() const;
//    QString toolTip() const;
//    QString whatsThis() const;
//};


} /* namespace gui */
} /* namespace mdcs */

#endif /* MORDICUSRUNCONTROL_H_ */
